# Java Source Code Formatting

Eclim provides the ability to format java source code using the eclipse formatter selected for your workspace.

Source code formatting is invoked in eclipse using the shortcut <C-S-F>, or from the `Source / Format menu`. The eclim equivalent is invoked using the :JavaFormat command described below.

- :JavaFormat - Formats the current visual selection (or the current line, if nothing is selected). To format the whole file, use :%JavaFormat.

Given the following file:

    /**
     * @return
     *
     * Service
     * for test Eclipse <C-F> formatting.
     */
     public
     static String
     getAbstractService
     ()
     {
       if (abstractService == null)
       {
         throw new RuntimeException( "abstractService isn't initialized !");
       }
       return abstractService;
     }

You can execute :%JavaFormat to format the code according to your eclipse settings.

    /**
      * @return
      *
      * Service for test Eclipse <C-F> formatting.
      */
    public static String getAbstractService() {
      if (abstractService == null) {
        throw new RuntimeException("abstractService isn't initialized !");
      }
      return abstractService;
    }

## Configuration

- org.eclim.java.format.strip_trialing_whitespace - When set to true, all trailing whitespace will be removed when formatting java code.

Aside from the above configuration, source code formatting is only configurable via the eclipse GUI. So to make changes to the eclipse java formatting rules, shutdown eclim, start the eclipse GUI and configure your settings via:

Preferences ‣ Java ‣ Code Style ‣ Formatter ‣ Active Profile: ‣ Edit